/**
 * RGBE (Radiance HDR) to linear float RGB conversion. The input vec is supposed
 * to contain unsigned byte values, with the last component being the exponent.
 *
 * @remarks
 * Reference: https://en.wikipedia.org/wiki/RGBE_image_format
 *
 * Code based on:
 * https://github.com/box/hdrCompressor/blob/master/src/rgbe/rgbe.c
 *
 */
export declare const decodeRGBE: import("@thi.ng/shader-ast").TaggedFn1<"ivec4", "vec3">;
//# sourceMappingURL=rgbe.d.ts.map